//-----------------------------------------------------------------------------
#ifndef SerCamApiExceptionsH
#define SerCamApiExceptionsH SerCamApiExceptionsH
//-----------------------------------------------------------------------------

namespace mv {

//-----------------------------------------------------------------------------
class ESerCamApi
//-----------------------------------------------------------------------------
{
	std::string		m_errorString;
	int				m_errorCode;
protected:
	void setErrString( const std::string& errorString ) { m_errorString = errorString; }
public:
	ESerCamApi( const std::string errstr, int errcode ) : m_errorString(errstr), m_errorCode(errcode) {}
	virtual ~ESerCamApi() {}
	const std::string&	errString( void ) const { return m_errorString; }
	int					errCode( void ) const { return m_errorCode; }
};

//-----------------------------------------------------------------------------
enum TSCAErrorCodes
//-----------------------------------------------------------------------------
{
	SCA_COMTIMEOUT = -5000,
	SCA_MSGLENGTH = -5001,
	SCA_NOPORTOPEN = -5002,
	SCA_BAUDRATENOTAVAILABLE = -5003,
	SCA_COMWRITEERROR = -5004,
	SCA_BUFFERSIZE = -5005,
	SCA_FUNCNOTFOUND = -5006,
	SCA_PARAMETER = -5007,
};

//-----------------------------------------------------------------------------
class EComTimeout : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	EComTimeout() : ESerCamApi("communication timeout", SCA_COMTIMEOUT ) {}
};

//-----------------------------------------------------------------------------
class EMessageLength : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	EMessageLength() : ESerCamApi("message length", SCA_MSGLENGTH ) {}
};

//-----------------------------------------------------------------------------
class ENoPortOpen : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	ENoPortOpen() : ESerCamApi("no port open", SCA_NOPORTOPEN ) {}
};

//-----------------------------------------------------------------------------
class EBaudrateNotAvailable : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	EBaudrateNotAvailable() : ESerCamApi("baudrate not available", SCA_BAUDRATENOTAVAILABLE ) {}
};

//-----------------------------------------------------------------------------
class EFunctionNotFound : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	EFunctionNotFound() : ESerCamApi("function not found", SCA_FUNCNOTFOUND ) {}
};

//-----------------------------------------------------------------------------
class EComWrite : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	EComWrite() : ESerCamApi("com write failure", SCA_COMWRITEERROR ) {}
};

//-----------------------------------------------------------------------------
class EBufferSize : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	EBufferSize() : ESerCamApi("buffer size too small", SCA_BUFFERSIZE ) {}
};

//-----------------------------------------------------------------------------
class EParameter : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	EParameter() : ESerCamApi("parameter error", SCA_PARAMETER ) {}
};


} // namespace mv

#endif // SerCamApiExceptionsH
